Code

config.c:store_write_pair(): don't read the byte before a malloc'd buffer.
[git.git] / git-rebase--interactive.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2006 Johannes E. Schindelin
5 # SHORT DESCRIPTION
6 #
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
9 #
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
13 USAGE='(--continue | --abort | --skip | [--preserve-merges] [--verbose]
14         [--onto <branch>] <upstream> [<branch>])'
16 . git-sh-setup
17 require_work_tree
19 DOTEST="$GIT_DIR/.dotest-merge"
20 TODO="$DOTEST"/git-rebase-todo
21 DONE="$DOTEST"/done
22 MSG="$DOTEST"/message
23 SQUASH_MSG="$DOTEST"/message-squash
24 REWRITTEN="$DOTEST"/rewritten
25 PRESERVE_MERGES=
26 STRATEGY=
27 VERBOSE=
28 test -d "$REWRITTEN" && PRESERVE_MERGES=t
29 test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
30 test -f "$DOTEST"/verbose && VERBOSE=t
32 warn () {
33         echo "$*" >&2
34 }
36 output () {
37         case "$VERBOSE" in
38         '')
39                 "$@" > "$DOTEST"/output 2>&1
40                 status=$?
41                 test $status != 0 &&
42                         cat "$DOTEST"/output
43                 return $status
44         ;;
45         *)
46                 "$@"
47         esac
48 }
50 require_clean_work_tree () {
51         # test if working tree is dirty
52         git rev-parse --verify HEAD > /dev/null &&
53         git update-index --refresh &&
54         git diff-files --quiet &&
55         git diff-index --cached --quiet HEAD -- ||
56         die "Working tree is dirty"
57 }
59 ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
61 comment_for_reflog () {
62         case "$ORIG_REFLOG_ACTION" in
63         ''|rebase*)
64                 GIT_REFLOG_ACTION="rebase -i ($1)"
65                 export GIT_REFLOG_ACTION
66         esac
67 }
69 mark_action_done () {
70         sed -e 1q < "$TODO" >> "$DONE"
71         sed -e 1d < "$TODO" >> "$TODO".new
72         mv -f "$TODO".new "$TODO"
73         count=$(($(wc -l < "$DONE")))
74         total=$(($count+$(wc -l < "$TODO")))
75         printf "Rebasing (%d/%d)\r" $count $total
76         test -z "$VERBOSE" || echo
77 }
79 make_patch () {
80         parent_sha1=$(git rev-parse --verify "$1"^ 2> /dev/null)
81         git diff-tree -p "$parent_sha1".."$1" > "$DOTEST"/patch
82 }
84 die_with_patch () {
85         test -f "$DOTEST"/message ||
86                 git cat-file commit $sha1 | sed "1,/^$/d" > "$DOTEST"/message
87         test -f "$DOTEST"/author-script ||
88                 get_author_ident_from_commit $sha1 > "$DOTEST"/author-script
89         make_patch "$1"
90         die "$2"
91 }
93 die_abort () {
94         rm -rf "$DOTEST"
95         die "$1"
96 }
98 pick_one () {
99         no_ff=
100         case "$1" in -n) sha1=$2; no_ff=t ;; *) sha1=$1 ;; esac
101         output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
102         test -d "$REWRITTEN" &&
103                 pick_one_preserving_merges "$@" && return
104         parent_sha1=$(git rev-parse --verify $sha1^ 2>/dev/null)
105         current_sha1=$(git rev-parse --verify HEAD)
106         if test $no_ff$current_sha1 = $parent_sha1; then
107                 output git reset --hard $sha1
108                 test "a$1" = a-n && output git reset --soft $current_sha1
109                 sha1=$(git rev-parse --short $sha1)
110                 output warn Fast forward to $sha1
111         else
112                 output git cherry-pick "$@"
113         fi
116 pick_one_preserving_merges () {
117         case "$1" in -n) sha1=$2 ;; *) sha1=$1 ;; esac
118         sha1=$(git rev-parse $sha1)
120         if test -f "$DOTEST"/current-commit
121         then
122                 current_commit=$(cat "$DOTEST"/current-commit) &&
123                 git rev-parse HEAD > "$REWRITTEN"/$current_commit &&
124                 rm "$DOTEST"/current-commit ||
125                 die "Cannot write current commit's replacement sha1"
126         fi
128         # rewrite parents; if none were rewritten, we can fast-forward.
129         fast_forward=t
130         preserve=t
131         new_parents=
132         for p in $(git rev-list --parents -1 $sha1 | cut -d\  -f2-)
133         do
134                 if test -f "$REWRITTEN"/$p
135                 then
136                         preserve=f
137                         new_p=$(cat "$REWRITTEN"/$p)
138                         test $p != $new_p && fast_forward=f
139                         case "$new_parents" in
140                         *$new_p*)
141                                 ;; # do nothing; that parent is already there
142                         *)
143                                 new_parents="$new_parents $new_p"
144                         esac
145                 fi
146         done
147         case $fast_forward in
148         t)
149                 output warn "Fast forward to $sha1"
150                 test $preserve=f && echo $sha1 > "$REWRITTEN"/$sha1
151                 ;;
152         f)
153                 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
155                 first_parent=$(expr "$new_parents" : " \([^ ]*\)")
156                 # detach HEAD to current parent
157                 output git checkout $first_parent 2> /dev/null ||
158                         die "Cannot move HEAD to $first_parent"
160                 echo $sha1 > "$DOTEST"/current-commit
161                 case "$new_parents" in
162                 \ *\ *)
163                         # redo merge
164                         author_script=$(get_author_ident_from_commit $sha1)
165                         eval "$author_script"
166                         msg="$(git cat-file commit $sha1 | \
167                                 sed -e '1,/^$/d' -e "s/[\"\\]/\\\\&/g")"
168                         # No point in merging the first parent, that's HEAD
169                         new_parents=${new_parents# $first_parent}
170                         # NEEDSWORK: give rerere a chance
171                         if ! output git merge $STRATEGY -m "$msg" $new_parents
172                         then
173                                 echo "$msg" > "$GIT_DIR"/MERGE_MSG
174                                 die Error redoing merge $sha1
175                         fi
176                         ;;
177                 *)
178                         output git cherry-pick "$@" ||
179                                 die_with_patch $sha1 "Could not pick $sha1"
180                 esac
181         esac
184 nth_string () {
185         case "$1" in
186         *1[0-9]|*[04-9]) echo "$1"th;;
187         *1) echo "$1"st;;
188         *2) echo "$1"nd;;
189         *3) echo "$1"rd;;
190         esac
193 make_squash_message () {
194         if test -f "$SQUASH_MSG"; then
195                 COUNT=$(($(sed -n "s/^# This is [^0-9]*\([1-9][0-9]*\).*/\1/p" \
196                         < "$SQUASH_MSG" | tail -n 1)+1))
197                 echo "# This is a combination of $COUNT commits."
198                 sed -n "2,\$p" < "$SQUASH_MSG"
199         else
200                 COUNT=2
201                 echo "# This is a combination of two commits."
202                 echo "# The first commit's message is:"
203                 echo
204                 git cat-file commit HEAD | sed -e '1,/^$/d'
205                 echo
206         fi
207         echo "# This is the $(nth_string $COUNT) commit message:"
208         echo
209         git cat-file commit $1 | sed -e '1,/^$/d'
212 peek_next_command () {
213         sed -n "1s/ .*$//p" < "$TODO"
216 do_next () {
217         test -f "$DOTEST"/message && rm "$DOTEST"/message
218         test -f "$DOTEST"/author-script && rm "$DOTEST"/author-script
219         read command sha1 rest < "$TODO"
220         case "$command" in
221         \#|'')
222                 mark_action_done
223                 ;;
224         pick)
225                 comment_for_reflog pick
227                 mark_action_done
228                 pick_one $sha1 ||
229                         die_with_patch $sha1 "Could not apply $sha1... $rest"
230                 ;;
231         edit)
232                 comment_for_reflog edit
234                 mark_action_done
235                 pick_one $sha1 ||
236                         die_with_patch $sha1 "Could not apply $sha1... $rest"
237                 make_patch $sha1
238                 warn
239                 warn "You can amend the commit now, with"
240                 warn
241                 warn "  git commit --amend"
242                 warn
243                 exit 0
244                 ;;
245         squash)
246                 comment_for_reflog squash
248                 test -z "$(grep -ve '^$' -e '^#' < $DONE)" &&
249                         die "Cannot 'squash' without a previous commit"
251                 mark_action_done
252                 make_squash_message $sha1 > "$MSG"
253                 case "$(peek_next_command)" in
254                 squash)
255                         EDIT_COMMIT=
256                         USE_OUTPUT=output
257                         cp "$MSG" "$SQUASH_MSG"
258                 ;;
259                 *)
260                         EDIT_COMMIT=-e
261                         USE_OUTPUT=
262                         test -f "$SQUASH_MSG" && rm "$SQUASH_MSG"
263                 esac
265                 failed=f
266                 author_script=$(get_author_ident_from_commit HEAD)
267                 output git reset --soft HEAD^
268                 pick_one -n $sha1 || failed=t
269                 echo "$author_script" > "$DOTEST"/author-script
270                 case $failed in
271                 f)
272                         # This is like --amend, but with a different message
273                         eval "$author_script"
274                         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
275                         $USE_OUTPUT git commit -F "$MSG" $EDIT_COMMIT
276                         ;;
277                 t)
278                         cp "$MSG" "$GIT_DIR"/MERGE_MSG
279                         warn
280                         warn "Could not apply $sha1... $rest"
281                         die_with_patch $sha1 ""
282                 esac
283                 ;;
284         *)
285                 warn "Unknown command: $command $sha1 $rest"
286                 die_with_patch $sha1 "Please fix this in the file $TODO."
287         esac
288         test -s "$TODO" && return
290         comment_for_reflog finish &&
291         HEADNAME=$(cat "$DOTEST"/head-name) &&
292         OLDHEAD=$(cat "$DOTEST"/head) &&
293         SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
294         if test -d "$REWRITTEN"
295         then
296                 test -f "$DOTEST"/current-commit &&
297                         current_commit=$(cat "$DOTEST"/current-commit) &&
298                         git rev-parse HEAD > "$REWRITTEN"/$current_commit
299                 NEWHEAD=$(cat "$REWRITTEN"/$OLDHEAD)
300         else
301                 NEWHEAD=$(git rev-parse HEAD)
302         fi &&
303         message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO)" &&
304         git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
305         git symbolic-ref HEAD $HEADNAME && {
306                 test ! -f "$DOTEST"/verbose ||
307                         git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
308         } &&
309         rm -rf "$DOTEST" &&
310         warn "Successfully rebased and updated $HEADNAME."
312         exit
315 do_rest () {
316         while :
317         do
318                 do_next
319         done
322 while test $# != 0
323 do
324         case "$1" in
325         --continue)
326                 comment_for_reflog continue
328                 test -d "$DOTEST" || die "No interactive rebase running"
330                 # commit if necessary
331                 git rev-parse --verify HEAD > /dev/null &&
332                 git update-index --refresh &&
333                 git diff-files --quiet &&
334                 ! git diff-index --cached --quiet HEAD -- &&
335                 . "$DOTEST"/author-script &&
336                 export GIT_AUTHOR_NAME GIT_AUTHOR_NAME GIT_AUTHOR_DATE &&
337                 git commit -F "$DOTEST"/message -e
339                 require_clean_work_tree
340                 do_rest
341                 ;;
342         --abort)
343                 comment_for_reflog abort
345                 test -d "$DOTEST" || die "No interactive rebase running"
347                 HEADNAME=$(cat "$DOTEST"/head-name)
348                 HEAD=$(cat "$DOTEST"/head)
349                 git symbolic-ref HEAD $HEADNAME &&
350                 output git reset --hard $HEAD &&
351                 rm -rf "$DOTEST"
352                 exit
353                 ;;
354         --skip)
355                 comment_for_reflog skip
357                 test -d "$DOTEST" || die "No interactive rebase running"
359                 output git reset --hard && do_rest
360                 ;;
361         -s|--strategy)
362                 case "$#,$1" in
363                 *,*=*)
364                         STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
365                 1,*)
366                         usage ;;
367                 *)
368                         STRATEGY="-s $2"
369                         shift ;;
370                 esac
371                 ;;
372         --merge)
373                 # we use merge anyway
374                 ;;
375         -C*)
376                 die "Interactive rebase uses merge, so $1 does not make sense"
377                 ;;
378         -v|--verbose)
379                 VERBOSE=t
380                 ;;
381         -p|--preserve-merges)
382                 PRESERVE_MERGES=t
383                 ;;
384         -i|--interactive)
385                 # yeah, we know
386                 ;;
387         ''|-h)
388                 usage
389                 ;;
390         *)
391                 test -d "$DOTEST" &&
392                         die "Interactive rebase already started"
394                 git var GIT_COMMITTER_IDENT >/dev/null ||
395                         die "You need to set your committer info first"
397                 comment_for_reflog start
399                 ONTO=
400                 case "$1" in
401                 --onto)
402                         ONTO=$(git rev-parse --verify "$2") ||
403                                 die "Does not point to a valid commit: $2"
404                         shift; shift
405                         ;;
406                 esac
408                 require_clean_work_tree
410                 mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
411                 if test ! -z "$2"
412                 then
413                         output git show-ref --verify --quiet "refs/heads/$2" ||
414                                 die "Invalid branchname: $2"
415                         output git checkout "$2" ||
416                                 die "Could not checkout $2"
417                 fi
419                 HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
420                 UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
422                 test -z "$ONTO" && ONTO=$UPSTREAM
424                 : > "$DOTEST"/interactive || die "Could not mark as interactive"
425                 git symbolic-ref HEAD > "$DOTEST"/head-name ||
426                         die "Could not get HEAD"
428                 echo $HEAD > "$DOTEST"/head
429                 echo $UPSTREAM > "$DOTEST"/upstream
430                 echo $ONTO > "$DOTEST"/onto
431                 test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
432                 test t = "$VERBOSE" && : > "$DOTEST"/verbose
433                 if test t = "$PRESERVE_MERGES"
434                 then
435                         # $REWRITTEN contains files for each commit that is
436                         # reachable by at least one merge base of $HEAD and
437                         # $UPSTREAM. They are not necessarily rewritten, but
438                         # their children might be.
439                         # This ensures that commits on merged, but otherwise
440                         # unrelated side branches are left alone. (Think "X"
441                         # in the man page's example.)
442                         mkdir "$REWRITTEN" &&
443                         for c in $(git merge-base --all $HEAD $UPSTREAM)
444                         do
445                                 echo $ONTO > "$REWRITTEN"/$c ||
446                                         die "Could not init rewritten commits"
447                         done
448                         MERGES_OPTION=
449                 else
450                         MERGES_OPTION=--no-merges
451                 fi
453                 SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
454                 SHORTHEAD=$(git rev-parse --short $HEAD)
455                 SHORTONTO=$(git rev-parse --short $ONTO)
456                 cat > "$TODO" << EOF
457 # Rebasing $SHORTUPSTREAM..$SHORTHEAD onto $SHORTONTO
459 # Commands:
460 #  pick = use commit
461 #  edit = use commit, but stop for amending
462 #  squash = use commit, but meld into previous commit
464 # If you remove a line here THAT COMMIT WILL BE LOST.
466 EOF
467                 git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
468                         --abbrev=7 --reverse --left-right --cherry-pick \
469                         $UPSTREAM...$HEAD | \
470                         sed -n "s/^>/pick /p" >> "$TODO"
472                 test -z "$(grep -ve '^$' -e '^#' < $TODO)" &&
473                         die_abort "Nothing to do"
475                 cp "$TODO" "$TODO".backup
476                 git_editor "$TODO" ||
477                         die "Could not execute editor"
479                 test -z "$(grep -ve '^$' -e '^#' < $TODO)" &&
480                         die_abort "Nothing to do"
482                 output git checkout $ONTO && do_rest
483         esac
484         shift
485 done